using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Text;
namespace Theremino_HAL
{


	static class MemoryMappedFiles_Unix
	{

		// ======================================================================================
		//  MemoryMappedFile_Unix "theremino1.shared"
		// ======================================================================================

		public static MemoryMappedFile_Unix MMF1_Unix;

        public static void MemoryMappedFile_Init_Unix()
		{
			// ----------------------------------------- The DLL opens a file called "theremino1.shared" of 4000 bytes
			MMF1_Unix = new MemoryMappedFile_Unix();
		}

		public static float ReadSlot_Unix(Int32 Slot)
		{
			return MMF1_Unix.ReadSlot(Slot);
		}

        public static float ReadSlot_NoNan_Unix(Int32 Slot)
		{
			float n = MMF1_Unix.ReadSlot(Slot);
			if (float.IsNaN(n)) n = 0; 
			return n;
		}

        public static void WriteSlot_Unix(Int32 Slot, float Value)
		{
			MMF1_Unix.WriteSlot(Slot, Value);
		}

		public static void MemoryMappedFile_FillWithNanSleep_Unix()
		{
			for (Int32 i = 0; i <= 999; i++) {
                MMF1_Unix.WriteSlot(i, MemoryMappedFiles.NAN_Sleep);
			}
		}


		// ======================================================================================
		//   CLASS MemoryMappedFile_Unix
		// ======================================================================================
		public class MemoryMappedFile_Unix
		{

			[DllImport("ThereminoSlots")]
			private static extern int the_slot_init();

			[DllImport("ThereminoSlots")]
			private static extern int the_slot_exit();

			[DllImport("ThereminoSlots")]
			private static extern void the_slot_write(int slot, float value);

			[DllImport("ThereminoSlots")]
			private static extern float the_slot_read(int slot);

			// ---------------------------------------------------------------- construction / destruction
			internal MemoryMappedFile_Unix()
			{
				InitSlot();
			}

            ~MemoryMappedFile_Unix()
			{
				Destroy();
				//base.Finalize();
			}

			internal void Destroy()
			{
				ExitSlot();
			}


			// ======================================================================================
			//  PUBLIC FUNCTIONS
			// ======================================================================================
			public Int32 InitSlot()
			{
				return the_slot_init();
			}

			public Int32 ExitSlot()
			{
				return the_slot_exit();
			}

			public void WriteSlot(Int32 Slot, float Value)
			{
				the_slot_write(Slot, Value);
			}

			public float ReadSlot(Int32 Slot)
			{
				return the_slot_read(Slot);
			}

		}

	}
}

